#! /usr/bin/env node
/**
 * @author: Akshay Singh
 * @date: 11/21/2015
 * @company: Matter Inc
 */

var cray = require('commander');
var _ = require('lodash');
var Parser = require('../index');
var Editor = require('../editor/index');
var Table = require('cli-table');
var chalk = require('chalk');

function files(val) {
  return val.split(',');
}

cray
  .version('0.0.1')
  .option('-e, --epubs [<path(s)>]', "Specify epub files to parse.", files, '')
  .parse(process.argv);

var table = new Table({
  head: ['Epub Name', 'Directory', 'Status'],
  style: {head: ['blue']}
});

if (!_.isEmpty(cray.epubs)) {
  var epubs = Parser(cray.epubs);

  epubs.on('READY', function() {
    _.each(epubs.queue, function(epub) {
      table.push([epub.baseName, epub.dirName, (epub.error) ? chalk.red(epub.error.message) : chalk.green('Valid')]);
    });

    console.log(table.toString());
  });

} else {
  cray.help();

}
